/* bspl0088.c */
#include <stdio.h>
#include <signal.h>
#include <assert.h>
#include <setjmp.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

jmp_buf sprung;
sig_atomic_t fehler = 0;

void std_handler(int s) {
	fehler = s;
	longjmp(sprung,1);
}

void print_fehler(int f) {
	char * text;
	switch (f) {
		case SIGFPE:
			text = "Floating point-Fehler";
			break;
		case SIGABRT:
			text = "Programmabbruch";
			break;
		default:
			text = "Unbekannter Fehler";
	}
	printf("\n%s",text);
}

main() {
	assert(signal(SIGABRT,std_handler)!=SIG_ERR);
	assert(signal(SIGFPE,std_handler)!=SIG_ERR);
	srand(time(NULL));
	if(setjmp(sprung) == 0) {
		if(rand()%2)
			raise(SIGFPE);
		else if(rand()%3)
			raise(SIGABRT);
		printf("\nProgrammende");
	}
	else {
		printf("\nNa, Na, Na. Was soll das?");
		print_fehler(fehler);
	}
}